\ message sends.. 20050910sylee
: print-arg-frame { arg -- }
  hex
  10 0 do
    cr i . 1 backspaces ." th: " arg i cells + @ .
  loop decimal ;

create objcArgArray 256 cells allot align
variable objcArgFrame objcArgArray objcArgFrame !
variable objcVarArgFrame objcArgFrame objcVarArgFrame !
\ NOTE THAT YOU MUST
\ give 0 to 'u' if no x1 ... xu part are needed.
: objc-msg-make-frame ( x1 ... xu u -- )
  dup 0 ?do
    1- dup cells objcArgArray 2 cells + + rot swap !
  loop drop ;

: send-msg ( obj sel x1 ... xu u -- result )
  dup cells 2 cells + objcArgArray + 0 swap !
  objc-msg-make-frame objcArgFrame objc-send-msgv ;

: send-msgv ( obj sel x1 ... xu u -- result )
  dup 2 + objcArgArray !
  dup 0 ?do 1- dup cells objcArgArray 3 cells + + rot swap !  loop drop
  objcArgArray 2 cells + !
  objcArgArray 1 cells + !
  objcArgFrame objc-send-msgv-wrapper ;


\ structures 20040911sylee
struct
  cell% field ->method-name
  cell% field ->method-types
  cell% field ->method-imp
end-struct objc-method-struct

struct
  cell%                 field ->method-next
  cell%                 field ->method-count
  objc-method-struct    field ->method-list
end-struct objc-method-list-struct

struct
  cell% field ->meta-class
  cell% field ->super-class
  cell% field ->name
  cell% field ->version
  cell% field ->info
  cell% field ->instance-size
  cell% field ->ivars
  cell% field ->methods \ objc-method-list-struct
  cell% field ->dtable
  cell% field ->subclass-list
  cell% field ->sibling-class
  cell% field ->protocols
  cell% field ->gc-object-type
end-struct objc-class-struct


: print-objc_class-info ( cls -- )
  dup 0= if drop S" no such class!" type space exit then
      cr S" ============= CLASS INFO ====================" type
  dup cr S" CLASS NAME: " type 2 cells + @ dup asciiz-len type
  dup cr S" MetaClass class_pointer: " type 0 cells + @ .
  dup cr S" struct objc_class* super_class: " type 1 cells + @ .
  dup cr S" const char* name: " type 2 cells + @ .
  dup cr S" long version: " type 3 cells + @ .
  dup cr S" unsigned long info: " type 4 cells + @ .
  dup cr S" long instance_size: " type 5 cells + @ .
  dup cr S" struct objc_ivar_list* ivars: " type 6 cells + @ .
  dup cr S" struct objc_method_list* methods: " type 7 cells + @ .
  dup cr S" struct sarray * dtable: " type 8 cells + @ .
  dup cr S" struct objc_class* subclass_list: " type 9 cells + @ .
  dup cr S" struct objc_class* sibling_class: " type 10 cells + @ .
  dup cr S" struct objc_protocol_list *protocols: " type 11 cells + @ .
      cr S" void* gc_object_type: " type 12 cells + @ . ;

: print-Method-info ( method -- )
  dup 0= if drop S" no such method!" type space exit then
      cr S" ============= METHOD LIST INFO ==================" type
  dup cr S" SEL method_name: " type 0 cells + @ .
  dup cr S" const char* method_types: " type 1 cells + @ dup . space
space
         dup asciiz-len type
      cr S" IMP method_imp: " type 2 cells + @ . ;

: print-objc_method_list-info ( objc_method_list -- )
  dup 0= if drop S" no such method list!" type space exit then
      cr S" ============= OBJC METHOD LIST INFO =================="
type
  dup cr S" struct objc_method_list*  method_next: " type 0 cells + @ .
  dup cr S" int    method_count: " type 1 cells + @ dup .
  0 ?do
       dup 2 cells + \ skip method_next, method_count field
       i 3 cells * + \ starts of i'th method_list field
       print-Method-info
  loop drop ;

\ const char *sel_get_name (SEL selector)
libobjc sel_get_name ptr (ptr) sel_get_name

: print-sel-name ( sel -- )
  cr ." SEL: " dup 8 .r ." , char *:"
  sel_get_name dup 0 <> if
    dup 8 .r ." : " dup asciiz-len type
  else
    drop space ." (nil)"
  then ;
: print-objc_sel_names { cls -- }
  cls ->methods @ ->method-count @ 0 ?do
    cls ->methods @ ->method-list i 3 cells * + @
    print-sel-name
  loop ;
