\ convert C string to forth string and returns the forth string.
: cs>fs ( addr -- addr u )
  0 ( addr 0 )
    begin over over ( addr n addr n ) chars + ( addr n addr+n*chars )
      c@ ( addr n char ) 0> ( addr n truth )
    while ( addr n )
      1 + ( addr n+1 )
    repeat ;
' cs>fs alias ctof

\ convert forth string to c forth string and returns the forth string.
: ftoc ( c-addr u -- 'c-addr ) here dup >r over allot swap cmove 0 c,
align r> ;

\ "ccc" put char addr terminated with 0 on stack
: asciiz ( ca u "ccc" -- ca1 u )
  align create bounds ?do i c@ c, loop 0 c, ;
: asciiz-len ( ca -- len )
  0 begin 2dup + c@ 0 <> while 1+ repeat nip ;
